use super::*;

pub struct ControlFlowClass<C>(ControlFlow<(), C>);

impl<C> WeakFunctor for ControlFlowClass<C> {
    type F<'a, A: 'a> =  ControlFlow<A, C>
    where
        Self: 'a;
}

impl<C> Functor for ControlFlowClass<C> {
    fn fmap<'a, A: 'a, B: 'a>(f: impl 'a + FnOnce(A) -> B, fa: Self::F<'a, A>) -> Self::F<'a, B>
    where
        Self: 'a,
    {
        match fa {
            ControlFlow::Continue(c) => ControlFlow::Continue(c),
            ControlFlow::Break(a) => ControlFlow::Break(f(a)),
        }
    }
}

impl<C> Pure for ControlFlowClass<C> {
    fn pure<'a, A: 'a>(a: A) -> Self::F<'a, A>
    where
        Self: 'a,
    {
        ControlFlow::Break(a)
    }
}
